Subject: Re: [PATCH] make commit --interactive lock index

From: Paolo Bonzini <[email-masked]>
Date: Thu, 29 May 2008 15:12:56 +0200

Johannes Schindelin wrote:
> Hi,
> 
> On Thu, 29 May 2008, Paolo Bonzini wrote:
> 
>> @@ -233,6 +228,8 @@ static char *prepare_index(int argc, const char **argv, const char *prefix)
>>  	if (*argv)
>>  		pathspec = get_pathspec(prefix, argv);
>>  
>> +	assert (!(interactive && pathspec && *pathspec));
> 
> As pathspec is specified indirectly by the user, I think an assert() here 
> is actively wrong.

But the program may still guarantee a condition by checking it 
elsewhere.  I don't need to teach you about that, do I?  In particular, 
the assert checks that this:

if (interactive && argc > 0)
         die("Paths with --interactive does not make sense.");

... is equivalent to !pathspec || !*pathspec.

Paolo